--parser.e standalone memory access
--the low-level memory manipulators

--byte
global procedure poke_byte(atom a, object b) poke(a, b) end procedure
global function peek_byte(atom a) return peek(a) end function
--word
global procedure poke_word(atom a, object b) 
  if atom(b) then b = {b} end if
  for count = 1 to length(b) do
    poke(a, remainder(b[count], 256)) 
    poke(a + 1, floor(b[count] / 256)) 
  end for
end procedure
global function peek_word(atom a) return peek(a) + peek(a + 1) * 256 end function
--dword
global procedure poke_dword(atom a, object b) poke4(a, b) end procedure
global function peek_dword(atom a) return peek4u(a) end function
--fixed point
global procedure poke_fixpt(atom a, object b) poke4(a, b) end procedure
global function peek_fixpt(atom a) return peek4s(a) end function
--32-bit floating point
global procedure poke_float4(atom a, object b) 
  if atom(b) then b = {b} end if
  for count = 1 to length(b) do
    poke(a + (count - 1) * 8, atom_to_float32(b[count]))
  end for
end procedure
global function peek_float4(atom a) return float32_to_atom(peek({a, 8})) end function
--64-bit floating point
global procedure poke_float8(atom a, object b) 
  if atom(b) then b = {b} end if
  for count = 1 to length(b) do
    poke(a + (count - 1) * 8, atom_to_float64(b[count]))
  end for
end procedure
global function peek_float8(atom a) return float64_to_atom(peek({a, 8})) end function
--80-bit floating point
--global procedure poke_float10(atom a, atom b) poke(a, atom_to_float64(b)) end procedure
--global function peek_float10(atom a) return float64_to_atom(peek({a, 8})) end function
--real number(64 bit)
global procedure poke_real(atom a, object b) poke_float8(a,b) end procedure -----------
global function peek_real(atom a) return peek_float8(a) end function ------wrong!----
--complex numbers(64 bit)
global procedure poke_complex(atom a, object b) poke_float8(a,b[1]) poke_float8(a+8,b[2]) end procedure -----------
global function peek_complex(atom a) return {peek_float8(a),peek_float8(a+8)} end function ------wrong!----



